#include <cstdio>
#include <iostream>
#include <set>
#include <vector>

const int MAX_N = 1000;
int a[MAX_N][MAX_N];
int my[MAX_N][MAX_N];

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int N, W;
    scanf("%d", &N);
    scanf("%d", &W);

    for (int y = 0; y < N; ++y)
        for (int x = 0; x < N; ++x)
            scanf("%d", a[y] + x);
    
    std::multiset<int> ms;
    for (int x = 0; x < N; ++x) {
        ms.clear();
        for (int y = 0; y < N; ++y) {
            ms.insert(a[y][x]);
            if (y > 2 * W)
                ms.erase(ms.find(a[y - 2 * W - 1][x]));
            my[y][x] = *ms.begin();
        }
    }

    std::vector<std::pair<int, int> > res;
    for (int y = 0; y < N; ++y) {
        ms.clear();
        for (int x = 0; x < N; ++x) {
            ms.insert(my[y][x]);
            if (x > 2 * W)
                ms.erase(ms.find(my[y][x - 2 * W - 1]));
            if (x >= 2 * W && y >= 2 * W && a[y - W][x - W] == *ms.begin()) {
                res.push_back(std::make_pair(x - W + 1, y - W + 1));
            }
        }
    }

    printf("%d\n", res.size());
    for (int i = 0; i < res.size(); ++i)
        printf("%d %d\n", res[i].first, res[i].second);

    fclose(stdin);
    fclose(stdout);
}
