#include <cstdio>
#include <iostream>
#include <set>
#include <vector>

const int MAX_N = 1000;
int N, W;
int a[MAX_N][MAX_N];

bool is_depression(int xc, int yc) {
    for (int y = yc - W; y <= yc + W; ++y)
        for (int x = xc - W; x <= xc + W; ++x) {
            if (x < 0 || x >= N || y < 0 || y >= N || a[y][x] < a[yc][xc])
                return false;
        }
    return true;
}

int main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    scanf("%d", &N);
    scanf("%d", &W);

    for (int y = 0; y < N; ++y)
        for (int x = 0; x < N; ++x)
            scanf("%d", a[y] + x);
    
    std::vector<std::pair<int, int> > res;
    for (int yc = 0; yc < N; ++yc)
        for (int xc = 0; xc < N; ++xc)
            if (is_depression(xc, yc))
                res.push_back(std::make_pair(xc + 1, yc + 1));

    printf("%d\n", res.size());
    for (int i = 0; i < res.size(); ++i)
        printf("%d %d\n", res[i].first, res[i].second);

    fclose(stdin);
    fclose(stdout);
}
